    /*

    Requires the Qt widget libraries, available at no cost at 
    http://www.troll.no
       
    Copyright (C) 1997 Frithjof Brestrich 
                       brestrich@kde.org


    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    */
 
#include "toplevel.h"
#include "xf86vidmode.h"
#include <kapp.h>
#include <kmsgbox.h>

int main( int argc, char *argv[] )
{
  int  displaywarning;

  KApplication a( argc, argv, "kvidtune" );

  KConfig* cfg = a.getConfig();
  cfg->setGroup("misc");
  
  displaywarning = cfg->readNumEntry("displaywarning",TRUE);

  XF86VidMode     *VidMode;
  VidMode = new XF86VidMode();
  if (!VidMode->ConnectDisplay(kapp->getDisplay(),DefaultScreen(kapp->getDisplay()))) {
    QString txt;
    txt = klocale->translate("Cannot initialise XFree86-VidModeExtension.\n"
                             "Version number must be 0.5 or greater.\n\n"
                             "Given reason:\n");
    txt += klocale->translate(VidMode->LastErrorText());
    KMsgBox::message(NULL,klocale->translate("KVidTune - Fatal error"), txt,
		     KMsgBox::STOP, klocale->translate("&Terminate"));
    return -1;
  }
  if (!VidMode->RequestData()) {
    QString txt;
    txt = klocale->translate("Cannot receive XFree86-VidModeExtension data.\n\n"
                             "Given reason:\n");
    txt += klocale->translate(VidMode->LastErrorText());
    KMsgBox::message(NULL,klocale->translate("KVidTune - Fatal error"), txt,
		     KMsgBox::STOP, klocale->translate("&Terminate"));
    return -1;
  }
					     
  TopLevel *toplevel = new TopLevel(VidMode);
  toplevel->setUnsavedData(TRUE);
  toplevel->configLoad();
  kapp->setMainWidget(toplevel); 

  if (!displaywarning||KMsgBox::yesNo(toplevel, klocale->translate("WARNING  WARNING  WARNING  WARNING"),
                 klocale->translate(
                   "THE INCORRECT USE OF THIS PROGRAM CAN DO PERMANENT DAMAGE TO YOUR MONITOR\n"
                   "AND/OR VIDEO CARD.  IF YOU ARE NOT SURE WHAT YOU ARE DOING, HIT ABORT\n"
                   "NOW. OTHERWISE, HIT CONTINUE\n"
                   "\n"
                   "THE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND,\n"
                   "EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF\n"
                   "MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.\n"
                   "SEE THE \"GNU General Public License\" FOR MORE DETAILS.\n"
                   "\n"
                   "IN NO EVENT SHALL Frithjof Brestrich BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\n"
		   "LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING\n"
                   "FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER\n"
		   "DEALINGS IN THE SOFTWARE."),
                 KMsgBox::EXCLAMATION|KMsgBox::DB_SECOND,
                 klocale->translate("&Continue"),
                 klocale->translate("&Abort"))==1)
  {
    kapp->exec();
  }
  
  toplevel->configStore();
  cfg->sync();

  return 0;
}
